Unit MLU17_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU17(var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; var T :Array of Real;
                N :Integer; var NT :Array of Integer;
                var SUM :Array of Real; K :Integer;
                var XK :Array of Real);

implementation

procedure MLU17(var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; var T :Array of Real;
                N :Integer; var NT :Array of Integer;
                var SUM :Array of Real; K :Integer;
                var XK :Array of Real);
var
K1,K2,J,K3,I :Integer;
label
_2,_4,_1,_3;
begin
{     YMHOEHE MATP U(M,M) HA K-T }
{     CTOE MATP YCOB.MATPA YCOB }
{     XPAHTC KOMAKTHO. }
K1 := 0;
K2 := K-1;
if ( K2 = 0 )
 then goto _4;
for J:=1 to K2 do
 begin
  K3 := NT[J-1];
_2:
  K1 := K1+K3;
 end;
_4:
K3 := NT[K-1];
for I:=1 to M do
 begin
_1:
  XK[I-1] := U[(I-1)+(M-2)*M]*T[K-1]+U[(I-1)+(M-1)*M]*SUM[K-1];
 end;
for J:=1 to K3 do
 begin
  K1 := K1+1;
  K2 := NS[K1-1];
  for I:=1 to M do
   begin
_3:
    XK[I-1] := XK[I-1]+U[(I-1)+(K2-1)*M]*A[K1-1];
   end;
 end;
end;

end.
