Unit MLU05_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU05(var X :Array of Real; var XK :Array of Real;
                M :Integer; var L :Integer; var TETA :Real;
                EPS :Real);

implementation

procedure MLU05(var X :Array of Real; var XK :Array of Real;
                M :Integer; var L :Integer; var TETA :Real;
                EPS :Real);
var
M1,I :Integer;
R :Real;
const
CONS :Real = 10.0E10;
label
_1;
begin

{      BEKTOPOB X(M)  XK(M) BCTC }
{     OTHOEH X(I)/XK(I) ( XK(I) OX EPS). }
{     MHMAH PEYTAT CTABTC B TETA, }
{     COOTBETCTBY HOMEP -B L. }

TETA := CONS;
M1 := M-2;
for I:=1 to M1 do
 begin
  if ( XK[I-1] < EPS )
   then goto _1;
  R := X[I-1]/XK[I-1];
  if ( R >= TETA )
   then goto _1;
  TETA := R;
  L := I;
_1:
 end;
end;

end.
