Unit MLU13_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU13(var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; var NJ :Integer; J :Integer;
                K1 :Integer; var T :Array of Real;
                var SUM :Array of Real; N :Integer; var DEL1 :Real;
                var DEL2 :Real);

implementation

procedure MLU13(var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; var NJ :Integer; J :Integer;
                K1 :Integer; var T :Array of Real;
                var SUM :Array of Real; N :Integer; var DEL1 :Real;
                var DEL2 :Real);
var
I,K3 :Integer;
label
_1;
begin

{     BCEHE OEHOK DEL1  DEL2 (B }
{     BPOEHHOM CYAE)  J-TOO CTOA. }
{     MATPA XPAHTC KOMAKTHO. }

DEL1 := 0;
DEL2 := 0;
for I:=1 to K1 do
 begin
  K3 := NS[NJ-1];
  DEL1 := DEL1+U[(M-1)+(K3-1)*M]*A[NJ-1];
  DEL2 := DEL2+U[(M-2)+(K3-1)*M]*A[NJ-1];
_1:
  NJ := NJ+1;
 end;
DEL1 := DEL1+U[(M-1)+(M-2)*M]*T[J-1]+U[(M-1)+(M-1)*M]*SUM[J-1];
DEL2 := DEL2+U[(M-2)+(M-2)*M]*T[J-1]+U[(M-2)+(M-1)*M]*SUM[J-1];
end;

end.
