Unit MLU15_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN13_p, MLU12_p;

procedure MLU15(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; N :Integer;
                var T :Array of Real; var NT :Array of Integer;
                var NSUM :Array of Integer; var SUM :Array of Real;
                var K :Integer);

implementation

procedure MLU15(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; N :Integer;
                var T :Array of Real; var NT :Array of Integer;
                var NSUM :Array of Integer; var SUM :Array of Real;
                var K :Integer);
var
M1,NJ,J,K1,K2 :Integer;
DEL :Real;
label
_2,_1;
begin
{     BOP BBOMOO CTOA HA BTOPOM }
{     TAE.MATPA XPAHTC KOMAKTHO. }
MIN := 0.0;
M1 := M-2;
NJ := 1;
for J:=1 to N do
 begin
  K1 := NT[J-1];
  if ( K1 = 0 ) 
   then goto _1;
  UTMN13(J,NSUM,K2);
  if ( K2 = 1 ) 
   then goto _2;
  MLU12(U,M,A,DA,NS,NJ,J,K1,T,SUM,N,DEL);
  if ( DEL >= MIN )
   then goto _1;
  MIN := DEL;
  K := J;
  goto _1;
_2:
  NJ := NJ+K1;
_1:
 end;
end;

end.
