Unit MLU16_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN13_p, MLU13_p;

procedure MLU16(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; N :Integer;
                var T :Array of Real; var NT :Array of Integer;
                var NSUM :Array of Integer; EPS :Real;
                var SUM :Array of Real; var K :Integer);

implementation

procedure MLU16(var MIN :Real; var U :Array of Real; M :Integer;
                var A :Array of Real; DA :Integer;
                var NS :Array of Integer; N :Integer;
                var T :Array of Real; var NT :Array of Integer;
                var NSUM :Array of Integer; EPS :Real;
                var SUM :Array of Real; var K :Integer);
var
O1024,M1,NJ,J,K1,K2 :Integer;
DEL1,DEL2 :Real;
label
_2,_1;
begin
{     BOP BBOMOO CTOA B BPOEHHOM }
{     CYAE.MATPA XPAHTC KOMAKTHO. }
MIN := 0.0;
M1 := M-2;
NJ := 1;
for J:=1 to N do
 begin
  K1 := NT[J-1];
  if ( K1 = 0 ) 
   then goto _1;
  UTMN13(J,NSUM,K2);
  if ( K2 = 1 ) 
   then goto _2;
  MLU13(U,M,A,DA,NS,NJ,J,K1,T,SUM,N,DEL1,DEL2);
  if ( DEL2 >= MIN )
   then goto _1;
  if ( Abs(DEL1) >= EPS )
   then goto _1;
  MIN := DEL2;
  K := J;
  goto _1;
_2:
  NJ := NJ+K1;
_1:
 end;
end;

end.
